MODULE GripGetState!(SYSMODULE, VIEWONLY)

PROC GripCheckState(num interval)
    VAR rawbytes raw_data;
    VAR dnum interval_coded;
    !	
    SetGO GRIP_go_DLen, 1;
    SetGO GRIP_go_Cmd, 0x8b;
    WaitTime 1.0;
		
    SetGO GRIP_go_Cmd,0;
    ClearRawBytes raw_data;
    PackRawBytes interval,raw_data,1,\Float4;
    UnpackRawBytes raw_data,1,interval_coded\IntX:=UDINT;
    SetGO GRIP_go_DLen,6;
    SetGO GRIP_go_Data,interval_coded;
    SetGO GRIP_go_Data5,0x07;
    SetGO GRIP_go_Cmd,0x95;
    WaitTime 1.0;
ENDPROC

!Coverts bytes sent from gripper to real value, and returns this value
FUNC num GripGetPos(dnum position)
	VAR rawbytes raw_data;
	VAR num meas_position;
	ClearRawBytes raw_data;
	PackRawBytes position, raw_data, 1, \IntX:=UDINT;
	UnpackRawBytes raw_data, 1, meas_position \Float4;
	RETURN meas_position;
ENDFUNC

FUNC num GripGetVel(dnum velocity)
	VAR rawbytes raw_data;
	VAR num meas_velocity;
	ClearRawBytes raw_data;
	PackRawBytes velocity, raw_data, 1, \IntX:=UDINT;
	UnpackRawBytes raw_data, 1, meas_velocity \Float4;
	RETURN meas_velocity;
ENDFUNC

FUNC num GripGetCur(dnum current)
	VAR rawbytes raw_data;
	VAR num meas_current;
	ClearRawBytes raw_data;
	PackRawBytes current, raw_data, 1, \IntX:=UDINT;
	UnpackRawBytes raw_data, 1, meas_current \Float4;
	RETURN meas_current;
ENDFUNC

ENDMODULE